-- Script generated on 2/4/2003 2:48 PM
-- By: REDMOND\mpohto
-- Server: (LOCAL)

BEGIN TRANSACTION            
  DECLARE @JobID BINARY(16)  
  DECLARE @ReturnCode INT    
  SELECT @ReturnCode = 0     
IF (SELECT COUNT(*) FROM msdb.dbo.syscategories WHERE name = N'Database Maintenance') < 1 
  EXECUTE msdb.dbo.sp_add_category @name = N'Database Maintenance'

  -- Delete the job with the same name (if it exists)
  SELECT @JobID = job_id     
  FROM   msdb.dbo.sysjobs    
  WHERE (name = N'_SQL_BackupDiffAll')       
  IF (@JobID IS NOT NULL)    
  BEGIN  
  -- Check if the job is a multi-server job  
  IF (EXISTS (SELECT  * 
              FROM    msdb.dbo.sysjobservers 
              WHERE   (job_id = @JobID) AND (server_id <> 0))) 
  BEGIN 
    -- There is, so abort the script 
    RAISERROR (N'Unable to import job ''_SQL_BackupDiffAll'' since there is already a multi-server job with this name.', 16, 1) 
    GOTO QuitWithRollback  
  END 
  ELSE 
    -- Delete the [local] job 
    EXECUTE msdb.dbo.sp_delete_job @job_name = N'_SQL_BackupDiffAll' 
    SELECT @JobID = NULL
  END 

BEGIN 

  -- Add the job
  EXECUTE @ReturnCode = msdb.dbo.sp_add_job @job_id = @JobID OUTPUT , @job_name = N'_SQL_BackupDiffAll', @owner_login_name = N'sa', @description = N'Backs up all (non excluded/RO) databases. Runs with or without compression.', @category_name = N'Database Maintenance', @enabled = 0, @notify_level_email = 0, @notify_level_page = 0, @notify_level_netsend = 0, @notify_level_eventlog = 2, @delete_level= 0
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job steps
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobstep @job_id = @JobID, @step_id = 1, @step_name = N'Exclude These Databases', @command = N'EXEC msdb..SQLSpecifyDBExclusions ''ExampleDB''
-- up to 30 databases may be excuded from the backup and backup
-- reporting jobs from this step.', @database_name = N'master', @server = N'', @database_user_name = N'', @subsystem = N'TSQL', @cmdexec_success_code = 0, @flags = 0, @retry_attempts = 0, @retry_interval = 1, @output_file_name = N'', @on_success_step_id = 0, @on_success_action = 3, @on_fail_step_id = 0, @on_fail_action = 2
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobstep @job_id = @JobID, @step_id = 2, @step_name = N'SQLBackupDiffAll01', @command = N'EXEC msdb..SQLBackupDiffAll01 compress, "e:\mssql\bak\diff"
--  Parmeters:
--     @compress (default=nocompress)  
--         Causes procedure to use SQLLiteSpeed compression or Standard SQL BAckup
--     @drive (default=E)
--         Specifies which drive \sql\bak\filename backups will be placed on.
--     @desc (default=SQL Backup)
--         SQLLIteSpeed description to be stored with the backup.
--     @threads (default=3) Valid values 1,2,3 or 0.
--         Determines the number of threads used for the backup. 
--         Best results have been identified at 2-3 for a multi processor server. 
--         Use n-1 threads, for n processor server.
--     @priority (default=0) Valid values 1,2,3 or 0.
--         Enables the priority of a SQLLiteSpeed backup to be increased to 1, 2 or 3
--         This setting could impact other processes so the default is zero.
--     @latency (default=nocompress) Valid Levels 0 through to 30.
--         This value is used to determine what latency level 
--         will be used for the backup. This command will slow down the backup and in effect 
--         reduce the CPU and I/O levels of the backup
--     @init (default=1) Valid values 1 or 0.
--         Used for SQLLIteSpeed backups to force backup file initialization, if value is set to 0
--         backups will be appended.
', @database_name = N'master', @server = N'', @database_user_name = N'', @subsystem = N'TSQL', @cmdexec_success_code = 0, @flags = 0, @retry_attempts = 0, @retry_interval = 1, @output_file_name = N'e:\SQLBackupDiffAllLog.txt', @on_success_step_id = 0, @on_success_action = 3, @on_fail_step_id = 0, @on_fail_action = 2
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobstep @job_id = @JobID, @step_id = 3, @step_name = N'SQLBackupDiffAll02 (with retry)', @command = N'EXEC msdb..SQLBackupDiffAll02', @database_name = N'master', @server = N'', @database_user_name = N'', @subsystem = N'TSQL', @cmdexec_success_code = 0, @flags = 2, @retry_attempts = 3, @retry_interval = 30, @output_file_name = N'e:\SQLBackupDiffAllLog.txt', @on_success_step_id = 0, @on_success_action = 1, @on_fail_step_id = 0, @on_fail_action = 2
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 
  EXECUTE @ReturnCode = msdb.dbo.sp_update_job @job_id = @JobID, @start_step_id = 1 

  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job schedules
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id = @JobID, @name = N'daily', @enabled = 1, @freq_type = 4, @active_start_date = 20010817, @active_start_time = 180000, @freq_interval = 1, @freq_subday_type = 1, @freq_subday_interval = 0, @freq_relative_interval = 0, @freq_recurrence_factor = 0, @active_end_date = 99991231, @active_end_time = 235959
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the Target Servers
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @JobID, @server_name = N'(local)' 
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

END
COMMIT TRANSACTION          
GOTO   EndSave              
QuitWithRollback:
  IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION 
EndSave: 




