use msdb
go

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[SQLBackupError]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SQLBackupError]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

create PROCEDURE SQLBackupError 
 @SQLError      int = 0
,@LSError       int = 0


AS
----------------------------------------------------------------------------------------------
--  Author Mark G. Pohto / Microsoft SQL Operations
----------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
-- This procedure Evaluates the return codes from standard sql backups or 
--  SQLLiteSpeed Backups.
--
--  Parmeters:
--     @SQLError (default=0)  
--         Error generated by a standard SQL Backup
--     @LSError  (default=0)
--         Error generated by a Compressed SQL Backup.
--  SQLBackupError 1,115
---------------------------------------------------------------------------------------------------
DECLARE @ErrorText varchar(200)
IF @SQLError != 0
BEgin
   SELECT @ErrorText = 'SQLBackupError '+RTRIM(convert(char,@SQLError))+' See SQL Books Online for more information.'
   EXEC master..xp_logevent 60000, @ErrorText, informational
   print @errorText
end
IF @LSError != 0
BEgin
   SELECT @ErrorText = 'SQLLSBackupError '+RTRIM(convert(char,@LSError))+' See SQLLiteSpeed documentation \\AITSQL2\G$\SQLLiteSpeed\Docs\SQLLiteSpeedErrors.doc for more information.'
   EXEC master..xp_logevent 60001, @ErrorText, informational
   print @errorText
end


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

